﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.IO.Compression;

namespace TestXMLandZip
{
	public class MyZIPCompressor
	{
		public static byte[] compress(String message)
		{
			byte[] buffer = System.Text.UTF8Encoding.UTF8.GetBytes(message.ToCharArray());

			MemoryStream ms = new MemoryStream();
			GZipStream compressedzipStream = new GZipStream(ms, CompressionMode.Compress, true);
			compressedzipStream.Write(buffer, 0, buffer.Length);
			compressedzipStream.Close();

			ms.Position = 0;
			byte[] data = new byte[ms.Length];
			ms.Read(data, 0, data.Length);

			compressedzipStream.Close();
			ms.Close();

			return data;
		}

		public static String decompress(byte[] data)
		{
			MemoryStream ms = new MemoryStream();
			ms.Write(data, 0, data.Length);

			ms.Position = 0;
			GZipStream zipStream = new GZipStream(ms, CompressionMode.Decompress, true);
			StreamReader reader = new StreamReader(zipStream);
			String message = reader.ReadToEnd();

			reader.Close();
			zipStream.Close();
			ms.Close();

			return message;
		}
	}
}
