﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace TestXMLandZip
{
	public class MyXMLSerializer
	{
		public static string SerializeObject(object o)
		{
			if (o != null)
			{
				XmlSerializer xmlser = new XmlSerializer(o.GetType());
				StringBuilder sb = new StringBuilder();
				System.IO.TextWriter tw = new System.IO.StringWriter(sb);
				xmlser.Serialize(tw, o);
				return tw.ToString();
			}
			return "";
		}

		public static string SerializeObject(object o, Type t)
		{
			if (o != null)
			{
				XmlSerializer xmlser = new XmlSerializer(t);
				StringBuilder sb = new StringBuilder();
				System.IO.TextWriter tw = new
				System.IO.StringWriter(sb);
				xmlser.Serialize(tw, o);
				return tw.ToString();
			}
			return "";
		}

		public static object DeserializeObject(string xml, Type t)
		{
			if ((xml != null) && (xml != ""))
			{
				XmlSerializer xmlser = new XmlSerializer(t);
				System.IO.TextReader tr = new
				System.IO.StringReader(xml);
				object objToRet;
				objToRet = xmlser.Deserialize(tr);
				return objToRet;
			}
			return "";
		}
	}
}

